//+------------------------------------------------------------------+
//|                                            ExecuteBuyOrder-R.mq4 |
//|                                            Copyright  2010, MTL |
//|                                 http://www.metatraderlibrary.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MTL"
#property link      "http://www.metatraderlibrary.com"
#property show_inputs
extern string TypeOfOrder = "####### BUY ORDER ######";
extern double Slippage = 5;
extern double RiskPercentage = 5;
extern string StratName = "Dashboard";
extern bool ShowChartComments = true;

#include <stderror.mqh>
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| script "Send Order"                                              |
//+------------------------------------------------------------------+


int deinit() {
    return( 0 );
}

int start()
  {
   int    ticket; double CalcLotSize, AcLotSize, RiskPerPip, PerPipValue, AdjLotSize, PipValue, HundPercentage, TargetInPips, StopInPips, SinglePercentage, CalcRiskPercentage, CalcReward,CalcRisk;
   
   
   
  double getUPPER = ObjectGet( "UPPER", OBJPROP_PRICE1); 
  double getLOWER = ObjectGet( "LOWER", OBJPROP_PRICE1); 

 StopInPips = ((Ask-getLOWER)/Point); 
 TargetInPips = ((getUPPER-Ask)/Point);
 PipValue = MarketInfo(Symbol(), MODE_TICKVALUE); 
 HundPercentage = AccountBalance()/100;
 CalcRiskPercentage = (HundPercentage*RiskPercentage); 

 RiskPerPip = (CalcRiskPercentage/MathRound(StopInPips));
 AdjLotSize= (RiskPerPip/PipValue); 
 PerPipValue = NormalizeDouble(AdjLotSize,2)*PipValue;
 CalcRisk = (NormalizeDouble(AdjLotSize,2)*PipValue)*MathRound(StopInPips);
 CalcReward = (NormalizeDouble(AdjLotSize,2)*PipValue)*MathRound(TargetInPips);


if (getLOWER>getUPPER) 
{Print("Reverse your Stop and Target Price Labels!"); Comment("Reverse your Stop and Target Price Labels!"); return(0);}  

if (AdjLotSize<0.01)
{Print("Sorry, Can't Trade Lot Size Less Than 0.01"); Comment("Sorry, Can't Trade Lot Size Less Than 0.01"); return(0);}
   
if (StopInPips < 5 || TargetInPips <5) 
{Print("Target and StopLoss Must Be At Least 5 Pips"); Comment("Target and StopLoss Must Be At Least 5 Pips"); return(0);}  

int checkforerrors;
checkforerrors = GetLastError();


 if (RiskPercentage>0 && getUPPER >0 && getLOWER>0)
     
     {
      ticket=OrderSend(Symbol(),OP_BUY,NormalizeDouble(AdjLotSize,2),Ask,Slippage,NormalizeDouble(getLOWER,Digits),NormalizeDouble(getUPPER,Digits),StratName+":"+"  Buy  "+Symbol()+"  "+NormalizeDouble(RiskPercentage,Digits)+"%",0,0,CLR_NONE);
      Print ("   LotSize=",NormalizeDouble(AdjLotSize,2)," Target= ",getUPPER, "  Stop= ",getLOWER, "  RiskAmount $",NormalizeDouble(CalcRisk,2), "  Reward $",NormalizeDouble(CalcReward,2), "  1LOT PipValue=$",PipValue, "  StopPips ",StopInPips, "  TargetPips ", TargetInPips );
      if(ticket<=0) Print("Error = ",ErrorDescription(checkforerrors)); Comment("Error = ",ErrorDescription(checkforerrors));
      if(ticket>0) { Print("ticket = ",ticket);
      if (ShowChartComments == true)
      {Comment("LotSize = ", NormalizeDouble(AdjLotSize,2),"  Risk % = ",RiskPercentage,"\n",
       "ValuePerPip = $",NormalizeDouble(PerPipValue,4) ,"\n",
       "Stop Pips = ",MathRound(StopInPips),"\n",       
       "Target Pips = ",MathRound(TargetInPips),"\n",
       "Risk      $",NormalizeDouble(CalcRisk,2),"\n",   
       "Reward $", NormalizeDouble(CalcReward,2));}
    

 }
   
      //---- 10 seconds wait
      Sleep(10000);
     }

//----
   return(0);
  }












//+------------------------------------------------------------------+